/*
 * Copyright (c)1999 ASTEC, Inc.
 *
 * The user MUST handle this program under LGPL Version 2.1.
 *
 * $Id: ns-bogus-locale.c,v 1.1 1999/10/21 12:33:29 tshiozak Exp $
 *
 */

/* Original Written By AoiMoe. */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <wchar.h>

#ifndef DPRINT
#define DPRINT (0)
#endif

#ifndef DPRINT_FULL
#define DPRINT_FULL (0)
#endif

#if DPRINT_FULL
#undef DPRINT
#define DPRINT (1)
#endif


int
wctomb(char *mb, wchar_t wc)
{
    static mbstate_t state;

    int ret = 0;
    int flBroken = 0;


    if ( !mb ) {
        /* initialize of global state */
        memchr(&state, 0, sizeof(state));
        return 0;
    }

    /* detect of broken MB_LEN_MAX */
    {
        char *retaddr;

        retaddr = *(char **)((char *)(&mb) - sizeof(void (*)()));

        /*
         * user action : paste into any "<textarea>" field.
         *      result : bus error.
         */
        {
            char *target_begin, *target_end;
            extern void _XmTextFieldCountBytes();
            extern void _XmTextFieldGetDropReciever();
            
            target_begin = (char *)&_XmTextFieldCountBytes;
            target_end = target_begin+0x100;

            if ( target_begin<retaddr && retaddr<target_end ) {
#if DPRINT
                fprintf(stderr,
                        "broken wctomb call detected :\n");
                fprintf(stderr,
                        "  retaddr=0x%08X, "
                        "_XmTextFieldCountBytes=0x%08X\n",
                        retaddr, (void *)&_XmTextFieldCountBytes);
#endif
                flBroken = -1;
            }
#if DPRINT_FULL
            else
                fprintf(stderr,
                        "wctomb  : retaddr=0x%08X, "
                        "_XmTextFieldCountBytes=0x%08X\n",
                        retaddr, (void *)&_XmTextFieldCountBytes);
#endif
        }

        /*
         * user action : double click on any "<input type=text>" field,
         *               to select a word.
         *      result : bus error.
         */
        {
            char *target_begin, *target_end;
            extern void _XmTextFieldSetDestination();

            target_begin = (char *)&_XmTextFieldSetDestination;
            target_end = target_begin+0x200;

            if ( target_begin<retaddr && retaddr<target_end ) {
#if DPRINT
                fprintf(stderr,
                        "broken wctomb call detected :\n");
                fprintf(stderr,
                        "  retaddr=0x%08X, "
                        "_XmTextFieldSetDestination=0x%08X\n",
                        retaddr, (void *)&_XmTextFieldSetDestination);
#endif
                flBroken = -1;
            }
#if DPRINT_FULL
            else
                fprintf(stderr,
                        "wctomb  : retaddr=0x%08X, "
                        "_XmTextFieldSetDestination=0x%08X\n",
                        retaddr, (void *)&_XmTextFieldSetDestination);
#endif
        }

    }
    
    if ( flBroken ) {
        char tmp[6];
        ret = wcrtomb(tmp, wc, &state);
        *mb = tmp[0];
    } else
        ret = wcrtomb(mb, wc, &state);
    
    return ret;
}


#ifdef UNDER_46
size_t
wcstombs(char *mbs, wchar_t const *wcs, size_t n)
{
    static mbstate_t state;

    int ret = 0;
    int flBroken = 0;


    /*
     * user action : store initial value for "<textarea>" field in any way.
     *      result : put many waring messages.
     */

#if 0
/* XXX : It seems not needed and not enough. */
/*
    {
        char *retaddr;
        
        retaddr = *(char **)((char *)(&mbs) - sizeof(void (*)()));
        
        {
            char *target_begin, *target_end;
            extern void XmTextFieldGetString();
            
            target_end = (char *)&XmTextFieldGetString;
            target_begin = target_end-0xa000;

            if ( target_begin<retaddr && retaddr<target_end ) {
#if DPRINT
                fprintf(stderr, "illegal mbstowcs call detected :\n");
                fprintf(stderr,
                        "  retaddr=0x%08X, "
                        "XmTextFieldGetString=0x%08X\n",
                        retaddr, (void *)&XmTextFieldGetString);
                flBroken = -1;
#endif
            }
#if DPRINT_FULL
            else
                fprintf(stderr,
                        "wcstombs : retaddr=0x%08X, "
                        "XmTextFieldGetString=0x%08X\n",
                        retaddr, (void *)&XmTextFieldGetString);
#endif
        }
    }
*/
#endif

    /* It seems the best way.... */
    if ( *wcs&0xffff0000 )
        flBroken = -1;

    if ( flBroken ) {
        strncpy(mbs, (char *)wcs, n);
        ret = strlen((char *)wcs);
        ret = (ret<n)?ret:n;
    } else {
        /* valid rune */
        ret = wcsrtombs(mbs, &wcs, n, &state);
    }

    return ret;
}
#endif /* UNDER_46 */


/* end of file */
